/**************************************************/
/***                                            ***/
/***     		Driver LC75824                  ***/
/***       Copyright X.Fenard  2009             ***/
/***                                            ***/
/***         version 20091015                   ***/
/***   											***/
/***   											***/
/***   											***/
/***                                            ***/
/**************************************************/
#include <stdio.h>
#include <conio.h>
#include "LC75824.h"



char Enable,Clock,Data,LC75Config ;

/**************************************************/



// Port: 0aucun max 12: S1/P1..//S12
//SegActif si 0; power On si 0

void LC75824Init( char Port,char SegActif, char Power)
{
char LED64[8]={0,0,0,0,0,0,0,0};
Enable=0; Clock=0; Data=0; LC75824SendP(); 	//init 
LC75Config=2*Port; 							// D0=0 courant drain CU normal
if (SegActif) LC75Config=LC75Config | 0x40; //SC
if (Power)  LC75Config=LC75Config | 0x80; 	//power; osc off si 1
LC75Config=LC75Config | 0x20; 				//DR si 1 1/2 bias
LC75824Send( LED64,0);						//charge LC75Config  
}





/**************************************************/

/*** Envoie la commande  ***/



/*** Envoie Trame LC75824Send  ***/
// commande pointe sur  8 octet: DATA52, DD la zone 0..3 
void LC75824Send( char *Commande,char DD)
{
char T;
Enable=0; 
Clock=0;
LC75824SendP();
LC75824SendN(0x41,8); //envoie l'adresse 0x41 LSB first
Enable=1;
LC75824SendP();
for (T=0;T<6; T++) LC75824SendN(*(Commande+T),8); //envoie data 48 
LC75824SendN(*(Commande+6),4); //envoie data 4, total 52
LC75824SendN(0,2); //envoie data Fixe 2
if (DD==0) LC75824SendN(LC75Config,8); //envoie data Fixe 8, LCConfog
	else LC75824SendN(0,8); //envoie data Fixe 8 total 10
LC75824SendN(DD,2); //envoie DD Fixe 2	
Enable=0; 
LC75824SendP();
}



/*** Envoie N bits, max 8   ***/
void LC75824SendN(char Commande,char N)
{char T;
for (T=1;T!=0; T=T<<1) 
	{ /* printf("%x",T); */
	Data= Commande &T;LC75824SendP();Clock=1; LC75824SendP();Clock=0;LC75824SendP();
	N=N-1; if (N==0) T=0;
	}	
}


//------------------------------------ hard
//D0:DI, D1:CLK, D2:CE

void LC75824SendP()
{
char K=0;
if (Enable) K=K|0x04;	/* DB25 pin4 */
if (Clock) K=K|0x02;	/* DB25 pin3 */
if (Data) K=K|0x01;		/* DB25 pin2 */
ParaOutData (K);
printf ("%x ",K); /* Un delai  */
}


